unit Async1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Grids, Db, SQLServer, DBCtrls, ExtCtrls, ComCtrls,
  StdCtrls, Dialogs, DBGrids;
                             
type                                                    
  TForm1 = class(TForm) 
    SQLServer1: TSQLServer;
    SQLQuery1: TSQLQuery;
    DataSource1: TDataSource;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    DBGrid1: TDBGrid;
    Button6: TButton;
    SQLQuery2: TSQLQuery;
    Button1: TButton;
    Button2: TButton;
    Splitter1: TSplitter;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    procedure FormShow(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure SQLQuery2ThreadReady(Sender: TObject);
    procedure SQLQuery2ThreadMsg(Sender: TObject; aMsg: String);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
     with SQLServer1 do begin
          DataBaseName := 'pubs';
          UserName     := 'sa';
          ServerName   := '';
          Password     := '';
     end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var t1 : cardinal;
begin
     Screen.Cursor := crHourGlass;
     SQLQuery2.AsyncOpen;
     Statusbar1.Panels[1].text := 'Query2 running';
     t1 := GetTickCount;
     SQLQuery1.Open;
     StatusBar1.Panels[0].Text := 'Query1 finished';
     StatusBar1.Panels[2].Text := IntToStr(GetTickCount-t1)+' ms';
     Screen.Cursor := crDefault;
end;

procedure TForm1.Button6Click(Sender: TObject);
var t1 : cardinal;
begin
     Screen.Cursor := crHourGlass;
     t1 := GetTickCount;
     SQLQuery1.Open;
     StatusBar1.Panels[0].Text := 'Query1 finished';
     Statusbar1.Panels[1].text := 'Query2 running';
     SQLQuery2.Open;
     StatusBar1.Panels[1].Text := 'Query2 finished';
     StatusBar1.Panels[2].Text := IntToStr(GetTickCount-t1)+' ms';
     Screen.Cursor := crDefault;
end;

procedure TForm1.Button2Click(Sender: TObject);           
begin
     SQLQuery1.Close;
     SQLQuery2.AsyncClose; 
     Statusbar1.Panels[0].Text := '';
     Statusbar1.Panels[1].Text := '';
     Statusbar1.Panels[2].Text := '';
end;

procedure TForm1.SQLQuery2ThreadReady(Sender: TObject);
begin
     Statusbar1.Panels[1].text := 'Query2 finished';
end;

procedure TForm1.SQLQuery2ThreadMsg(Sender: TObject; aMsg: String);
begin
     Statusbar1.Panels[1].text := aMsg;
end;

end.
